"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _WorkerInterface = _interopRequireDefault(require("./WorkerInterface"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var defaultOptions = {
  workerAckTimeout: 3 * 1000
};

var connect = function connect(StreamComponent) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultOptions,
      workerAckTimeout = _ref.workerAckTimeout;

  var ConnectedScanner = function ConnectedScanner(_ref2) {
    var onDecode = _ref2.onDecode,
        onScannerLoad = _ref2.onScannerLoad,
        props = _objectWithoutProperties(_ref2, ["onDecode", "onScannerLoad"]);

    var handleDecode = _react["default"].useCallback(function (result) {
      if (result !== null && typeof onDecode == "function") {
        onDecode(result);
      }
    }, [onDecode]);

    var _React$useState = _react["default"].useState("pending"),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        workerState = _React$useState2[0],
        setWorkerState = _React$useState2[1];

    var worker = _react["default"].useMemo(function () {
      if (typeof Worker !== "undefined") {
        return new _WorkerInterface["default"]();
      } else {
        console.warn("Failed to start a Web Worker");
        return null;
      }
    }, []);

    var _React$useState3 = _react["default"].useState(null),
        _React$useState4 = _slicedToArray(_React$useState3, 2),
        mainDecoder = _React$useState4[0],
        setMainDecoder = _React$useState4[1];

    var handleWorkerLoad = _react["default"].useCallback( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var loadableJsQR;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return worker.ack(workerAckTimeout);

            case 3:
              setWorkerState("active");
              typeof onScannerLoad == "function" && onScannerLoad();
              _context.next = 22;
              break;

            case 7:
              _context.prev = 7;
              _context.t0 = _context["catch"](0);
              console.warn(_context.t0);
              setWorkerState("inactive");
              _context.prev = 11;
              _context.next = 14;
              return import("jsqr");

            case 14:
              loadableJsQR = _context.sent;
              setMainDecoder({
                decode: loadableJsQR["default"]
              });
              typeof onScannerLoad == "function" && onScannerLoad();
              _context.next = 22;
              break;

            case 19:
              _context.prev = 19;
              _context.t1 = _context["catch"](11);
              console.error(_context.t1);

            case 22:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 7], [11, 19]]);
    })), [worker, onScannerLoad]);

    _react["default"].useEffect(function () {
      handleWorkerLoad();
      return function () {
        if (worker !== null) {
          setWorkerState("pending");
          worker.onDestroy();
        }
      };
    }, [worker, handleWorkerLoad]);

    var handleCapture = _react["default"].useCallback( /*#__PURE__*/function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(imageData) {
        var result, data, width, height, _result;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(worker !== null && workerState !== "inactive")) {
                  _context2.next = 7;
                  break;
                }

                _context2.next = 3;
                return worker.requestDecoding(imageData);

              case 3:
                result = _context2.sent;
                handleDecode(result);
                _context2.next = 8;
                break;

              case 7:
                if (mainDecoder !== null) {
                  data = imageData.data, width = imageData.width, height = imageData.height;
                  _result = mainDecoder.decode(data, width, height);
                  handleDecode(_result);
                }

              case 8:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x) {
        return _ref4.apply(this, arguments);
      };
    }(), [mainDecoder, worker, workerState, handleDecode]);

    return /*#__PURE__*/_react["default"].createElement(StreamComponent, _extends({
      onCapture: handleCapture
    }, props));
  };

  ConnectedScanner.propTypes = {
    onDecode: _propTypes["default"].func,
    onScannerLoad: _propTypes["default"].func,
    captureSize: _propTypes["default"].objectOf(_propTypes["default"].number),
    constraints: _propTypes["default"].object
  };
  return ConnectedScanner;
};

var _default = connect;
exports["default"] = _default;